/*------------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
/* SI.C
**   SINCE directory display program
**   by Henry C. Clark
**    thanks to Blaise Computing, Inc.
*/
/*------------------------------------------------------------------------*/
#include "stdio.h"

/*------------------------------------------------------------------------*/
int drchdir();               /* Change the current directory *//* Blaise */
int drcurdir();              /* Return the current directory *//* Blaise */
int drsfirst();              /* Find the first matching file *//* Blaise */
int drsnext();               /* Find the next matchinf file  *//* Blaise */

char *malloc();
char *fmttime();

/*------------------------------------------------------------------------*/
struct file_spec             /* File information structure   *//* Blaise */
{                            /* used by drsfirst and drsnext *//* Blaise */
    int      fattr;             /* Attribute  (1 byte)    *//* Blaise */
    unsigned ftime;             /* Time stamp             *//* Blaise */
    unsigned fdate;             /* Date stamp             *//* Blaise */
    long     fsize;             /* File size in bytes    *//* Blaise */
    char     fname[13];         /* File name            *//* Blaise */
};

struct time_spec            /* order and alignment is crutial */
{
  unsigned yr, mn, da, hr, mi, sc, hu;
};

/*------------------------------------------------------------------------*/
struct file_spec finfo;       /* file information */
struct time_spec sinfo;       /* time information */
int fc;                       /* file count */
long ts;                      /* total files size */
char name1[35];               /* input file name spec */

																  /* .EXE starts here     */
/*------------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
main(argc,argv)
int argc;
char *argv[];
{
    int parmcnt, i, driv;
    char time1[35], curdir[67];
    int *n;
    char *ptr;
    int since();
                                                 /* validate parms */
/*------------------------------------------------------------------------*/
    if ( argc != 3 )
    {
      printf( " use >si file.ext [yr-][mn-][da:][hr:][mn]\n" );
      exit(0);
    }
    sscanf(argv[1],"%s",name1);
    sscanf(argv[2],"%s",time1);
                                                  /* get system time */
/*------------------------------------------------------------------------*/
    qyretdat( &sinfo.yr, &sinfo.mn, &sinfo.da );               /* Blaise */
    qyrettim( &sinfo.hr, &sinfo.mi, &sinfo.sc, &sinfo.hu );    /* Blaise */
    sinfo.yr -= 1900;
    sinfo.sc = 0;
    sinfo.hu = 0;
                                                  /* since-time token cnt */
/*------------------------------------------------------------------------*/
    ptr = (char *)&time1;
    parmcnt = 1;
    while ( *ptr != 0 )
    {
      if ( ( *ptr == '-' ) || ( *ptr == ':' ) )
        parmcnt++;
      ptr++;
    }
    if ( parmcnt > 5 )
    {
      printf( " try >si file.ext yr-mn-da:hr:mn\n" );
      exit(0);
    }
                                                    /* since-time decode */
/*------------------------------------------------------------------------*/
    n = (int *)&sinfo.mi;
    ptr--;
    while ( parmcnt > 0 )
    {
      i = ( int )*(ptr--) - 48;
      if ( ( *ptr != '-' ) &&
           ( *ptr != ':' ) &&
           ( ptr >= (char *)&time1 ) )
        i += ( (int )*(ptr--) - 48 ) * 10;
      *n-- = i;

      ptr--;
      parmcnt--;
    }
                                                   /* print header */
/*------------------------------------------------------------------------*/
    fc = 0;
    ts = 0;
    drcurdir( 0, &curdir );                                     /* Blaise */
    printf("SINCE %02d-%02d-%02d %02d:%02d\n", sinfo.yr, sinfo.mn,
            sinfo.da, sinfo.hr, sinfo.mi );
    printf("%s\n",&curdir);
                                                  /* hunt matching files */
/*------------------------------------------------------------------------*/
    dirhunt( 0, '.' );
    printf("     %4d files  %ld bytes\n", fc, ts );
}
                                                  /* recursive routine */
/*------------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
dirhunt ( ofs, dr )
 int ofs;
 char *dr;
{
  extern char drbuffer[48];                                    /* Blaise */
  char tempbuf[48];
                                                  /* get first file */
/*------------------------------------------------------------------------*/
  drchdir ( dr );                                              /* Blaise */
  if ( drsfirst ( name1, 23, &finfo ) )                        /* Blaise */
  {
    printf ( " file not found.\n" );
    if ( ofs != 0 )
      drchdir ( ".." );                                         /* Blaise */
    return(0);
  }
  if ( ( finfo.fattr == 16 ) && ( finfo.fname[0] != '.' ) )
  {
    disp_info ( &finfo, ofs );
    movmem ( drbuffer, tempbuf, 48 );
    dirhunt( ofs + 4, finfo.fname );
    movmem ( tempbuf, drbuffer, 48 );
  }
  else
  {
    if ( since ( &finfo, &sinfo ) )
    {
      disp_info ( &finfo,ofs );
      fc++;
      ts += finfo.fsize;
    }
  }
                                                  /* subsequent files */
/*------------------------------------------------------------------------*/
  while ( !drsnext(&finfo) )                                    /* Blaise */
  {
    if ( ( finfo.fattr == 16 ) && ( finfo.fname[0] != '.' ) )
    {
      disp_info ( &finfo,ofs );
      movmem ( drbuffer, tempbuf, 48 );
      dirhunt( ofs + 4, finfo.fname );
      movmem ( tempbuf, drbuffer, 48 );
    }
    else
    {
      if ( since ( &finfo, &sinfo ) )
      {
        disp_info ( &finfo,ofs );
        fc++;
        ts += finfo.fsize;
      }
    }
  }
                                                  /* back to orig dir */
/*------------------------------------------------------------------------*/
  if ( ofs != 0 )
    drchdir ( ".." );
}
                                                  /* compare times  */
/*------------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
int since ( f, s )
 struct file_spec *f;
 struct time_spec *s;
{
  unsigned d, t;
                                                   /* date and time form */
/*------------------------------------------------------------------------*/
  d = ( ( s->yr - 80 ) << 9 ) | ( s->mn << 5 ) | s->da;
  t = ( s->hr << 11 ) | ( s->mi << 5 );

/*------------------------------------------------------------------------*/
  if (  d  <  f->fdate  )
    return(1);
  else
  {
    if ( d  ==  f->fdate  )
    {
      if (  t  <=  f->ftime  )
        return(1);
      else
        return(0);
    }
    else
      return(0);
  }
}
                                                  /* file stat display */
/*------------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
disp_info ( f, o )
 struct file_spec *f;
 int o;
{
    int i, j, getbits();
    bool kbhit();
    char c;
                                                  /* sub-dir offset level */
/*------------------------------------------------------------------------*/
    for ( i=0; i<o; i++ )
      printf(" ");
    j=0;
    i=0;
                                                   /* file name output */
/*------------------------------------------------------------------------*/
    if ( f->fattr == 16 )
    {
      while ( ( f->fname[i] != ' ' ) &&
              ( f->fname[i] != 0 ) )
      {
        printf ( "%c",f->fname[i] );
        j++;
        i++;
      }
    }
    else
    {
      while ( ( f->fname[i] != '.' ) &&
              ( f->fname[i] != ' ' ) &&
				  ( f->fname[i] != 0 ) )
      {
        printf ( "%c",f->fname[i] );
        j++;
        i++;
      }
    }
                                                  /* pad to extension */
/*------------------------------------------------------------------------*/
    while ( j++ < 8 )
      printf(" ");
                                                  /* extension output */
/*------------------------------------------------------------------------*/
    if ( f->fattr == 16 )
    {
      printf("<DIR>");
      j += 5;
    }
    else
    {
      while ( ( f->fname[i] != ' ' ) &&
              ( f->fname[i] != 0 ) )
      {
        printf ( "%c",f->fname[i] );
        j++;
        i++;
      }
    }
                                                  /* pad to size */
/*------------------------------------------------------------------------*/
    if ( f->fattr != 16 )
    {
      while ( j++ < 15 )
        printf(" ");
                                                  /* file size output */
/*------------------------------------------------------------------------*/
      printf("%8ld  ", f->fsize );
                                                  /* file date-time output */
/*------------------------------------------------------------------------*/
      printf( "%02u-", ( getbits ( f->fdate, 15, 7 ) + 80 ) );
      printf( "%02u-", ( getbits ( f->fdate, 8, 4 ) ) );
      printf( "%02u  ", ( getbits ( f->fdate, 4, 5 ) ) );
      printf( "%02u:", ( getbits ( f->ftime, 15, 5 ) ) );
      printf( "%02u:", ( getbits ( f->ftime, 10, 6 ) ) );
      printf( "%02u", ( getbits ( f->ftime, 4, 5 ) * 2 ) );
    }

	 printf( "\n" );

  }
                                                  /* shift right and mask */
/*------------------------------------------------------------------------*/
/*------------------------------------------------------------------------*/
int getbits ( x, p, n )
 unsigned x, p, n;
{
  return((x>>(p+1-n)) & ~(~0<<n));     /* K&R ( type mismatch )       */
}

